// //////////////////////////////////////////////////////////////////////
// Import section
// //////////////////////////////////////////////////////////////////////
#include <rmol/field/FldOverbookingPolicy.hpp>

namespace RMOL {

  // //////////////////////////////////////////////////////////////////////
  const std::string FldOverbookingPolicy::
  _labels[FldOverbookingPolicy::LAST_VALUE] = {"HEUR", "RISK", "SL1", "SL2",
                                               "HYBRID"};

  // //////////////////////////////////////////////////////////////////////
  FldOverbookingPolicy::
  FldOverbookingPolicy (const FldOverbookingPolicy& iPolicy) :
    _policy (iPolicy.getPolicy()) {
  }

  // //////////////////////////////////////////////////////////////////////
  FldOverbookingPolicy::
  FldOverbookingPolicy (const EN_Policy iPolicy) :
    _policy (iPolicy) {
  }

  // //////////////////////////////////////////////////////////////////////
  FldOverbookingPolicy::~FldOverbookingPolicy() {
  }
  
  // //////////////////////////////////////////////////////////////////////
  const std::string& FldOverbookingPolicy::
  getLabel (const FldOverbookingPolicy::EN_Policy& iPolicy) {
    return FldOverbookingPolicy::_labels[iPolicy];
  }

  // //////////////////////////////////////////////////////////////////////
  void FldOverbookingPolicy::toStream (std::ostream& ioOut) const {
    ioOut << getLabel (_policy);
  }
  
  // //////////////////////////////////////////////////////////////////////
  void FldOverbookingPolicy::fromStream (std::istream& ioIn) {
  }
  
}
